11.8.11   os16: proc_scheduler(9)

NOME

    proc_scheduler - schedulatore

SINTASSI

    <kernel/proc.h>
    void proc_scheduler (uint16_t *<sp>, segment_t *<segment_d>);

ARGOMENTI

    Argomento               Descrizione
    extern uint16_t <_ksp>; L'indice della pila del kernel.

    uint16_t *<sp>          Puntatore all'indice della pila del processo
                            interrotto.
    segment_t *<segment_d>  Puntatore al segmento dati del processo interrotto.

DESCRIZIONE

    La funzione <proc_scheduler()> viene avviata a seguito di un'interruzione
    hardware, dovuta al temporizzatore, oppure a seguito di un'interruzione
    software, dovuta a una chiamata di sistema.

    La funzione determina qual e` il processo interrotto, scandendo la tabella
    dei processi alla ricerca di quello il cui segmento dati corrisponde al
    valore <segment_d>. Per questo si avvale di proc_find(9) [11.8.5].

    Successivamente verifica se ci sono processi in attesa di un evento del
    temporizzatore o del terminale, inoltre verifica se ci sono processi con
    segnali in attesa di essere presi in considerazione. per fare questo si
    avvale di proc_sch_timers(9) [11.8.10], proc_sch_terminals(9) [11.8.9] e
    proc_sch_signals(9) [11.8.8], che provvedono a fare cio` che serve in
    presenza degli eventi di propria competenza.

    Si occupa quindi di annotare il tempo di CPU utilizzato dal processo appena
    sospeso, misurato in unita` di tempo a cui si riferisce il tipo clock_t.

    Successivamente scandisce la tabella dei processi alla ricerca di un altro
    processo da mettere in funzione, al posto di quello sospeso. Se trova un
    processo pronto per questo lo elegge a processo attivo, declassando quello
    sospeso a processo pronto ma in attesa, inoltre aggiorna i valori per le
    variabili <*sp> e <*segment_d>.

    Al termine salva nella variabile globale <_ksp> il valore dell'indice della
    pila del kernel, come appare nelle informazioni della tabella dei processi
    e poi manda il messaggio "EOI" (end of interrupt al "PIC 1" (programmable
    interrupt controller).

    Questa funzione viene usata dalla routine isr_1C(9) [11.8.1] del file
    kernel/proc/_isr.s e dalla funzione sysroutine(9) [11.8.28].

FILE SORGENTI

    kernel/proc.h [12.9]

    kernel/proc/_isr.s [12.9.1]

    kernel/proc/sysroutine.c [12.9.30]

    kernel/proc/proc_scheduler.c [12.9.11]

VEDERE ANCHE

    proc_find(9) [11.8.5], proc_sch_timers(9) [11.8.10], proc_sch_signals(9) [
    11.8.8], proc_sch_terminals(9) [11.8.9].

